import std.stdio;
import std.conv;

import elements;

/**
*  Ajoute un album à la collection de CD.
*
*  Retour:
*
*  Un album de la forme d'une classe ElementCD.
**/
ElementCD ajoutAlbum()
{
   ElementCD item;

      write("Nom de l'album : ");
      string tmpName = std.string.removechars(readln(), "\n");
      if(tmpName.length > 0)
      {
         item = new ElementCD;
         if(item !is null)
         {
            item.albumName = tmpName;
            writeln("Entrer le nom des pistes (ligne vide pour terminer la saisie) : ");

            bool endLoop = false;
            while (endLoop == false)
            {
               string trackName;

               write("Nom de la piste : ");
               trackName = std.string.removechars(readln(), "\n");
               if(trackName.length > 0)
               {
                  /* Ajoute la piste */
                  item.trackName = trackName;
               }
               else
               {
                  endLoop = true;
               }
            }
            write("Durée totale de l'album : ");
            string tmpTime = std.string.removechars(readln(), "\n");
            if(tmpTime.length > 0)
            {
               item.albumTime = to!uint(tmpTime);
            }
         }
      }
   else
   {
      write("Nom vide\nAppuyez sur Entrée");
      readln();
   }

   return item;
}

/**
*  Affiche la totalité des CD album par album.
*
*  Paramètre:
*
*  item  = La collection de CD sous la forme d'une classe ElementCD.
**/
void listAlbums(ElementCD[] item)
{
   if( item !is null && item.length > 0)
   {
      foreach(all ; item)
      {
         if( all is null)
         {
            write("Albums vides\nAppuyez sur Entrée");
            readln();
            return;
         }
         uint count = 0;
         writeln("Nom de l'album : ", all.albumName);
         foreach(curItem ; all.trackName)
         {
            writeln(to!string(count)~" : "~curItem);
            count++;
         }
         writeln("Temps de l'album : ", all.albumTime);
         write("Appuyez sur Entrée");
         readln();
      }
   }
}

/**
*  Supprime un album dans la collection
*
*  Paramètres:
*
*  allAlbums = La collection dans la quelle chercher. Cette même variable sera mise à jour si une suppression a eu lieu.
*
*  item      = Le nom de l'album à supprimer.
**/
void supprimerAlbum(ref ElementCD[] allAlbums, string item)
{
   if(allAlbums !is null && allAlbums.length > 0 && item.length > 0)
   {
      uint count = 0;
      foreach(all ; allAlbums)
      {
         if( all is null)
         {
            write("Albums vides\nAppuyez sur Entrée");
            readln();
            return;
         }
         if(all.albumName == item)
         {
            if(count == 0)
            {
               allAlbums = allAlbums[1..allAlbums.length];
            }
            else
            /* dernier élément à supprimer */
            if(count == allAlbums.length-1)
            {
               allAlbums = allAlbums[0..allAlbums.length-1];
            }
            else
            /* Sinon un élément dans la liste */
            if(count < allAlbums.length)
            {
               allAlbums = allAlbums[0..count] ~ allAlbums[count+1..allAlbums.length];
            }

            writeln("album "~item~" supprimé");
            write("Appuyez sur Entrée");
            readln();
            return;
         }
         count++;
      }
      writeln("Album "~item~" non trouvé");
      write("Appuyez sur Entrée");
      readln();
   }
   else
   {
      writeln("Album "~item~" non trouvé");
      write("Appuyez sur Entrée");
      readln();
   }
}

/**
*  Modifie la composition d'un album.
*  Cette fonction permet de modifier :
*
*  - Le nom d'un album.
*
*  - Le nom d'une piste.
*
*  - Le temps total de l'album.
*
*  Mais aussi de supprimer et/ou de rennomer des pistes.
*
*  Paramètres:
*
*  allAlbums = La collection dans la quelle chercher. Cette même variable sera mise à jour si une suppression a eu lieu.
*
*  item      = Le nom de l'album à supprimer.
**/
void modifierAlbum(ref ElementCD[] allAlbums, string item)
{
   if(allAlbums !is null && allAlbums.length > 0 && item.length > 0)
   {
      bool findAlbum = false;
      foreach(all ; allAlbums)
      {
         if( all is null)
         {
            write("Albums vides\nAppuyez sur Entrée");
            readln();
            return;
         }
         if(all.albumName == item)
         {
            findAlbum = true;
            write("Modifier le nom de l'(A)lbum, des (P)istes ou le temps du (C)D ? ");
            string choix = std.string.removechars(readln(), "\n");
            switch(choix)
            {
               case "A":
               case "a":
                  write("Nouveau nom de l'album : ");
                  all.albumName = std.string.removechars(readln(), "\n");
                  writeln("Nouveau nom pris en compte");
                  break;

               case "P":
               case "p":
                  write("(A)jouter, (M)odifier ou (S)upprimer une piste ? ");
                  string choixPiste = std.string.removechars(readln(), "\n");
                  switch(choixPiste)
                  {
                     case "A":
                     case "a":
                        write("Nom de la piste : ");
                        all.trackName = std.string.removechars(readln(), "\n");
                        writeln("Nouveau nom pris en compte");
                        break;

                     case "M":
                     case "m":
                        uint countItem = 0;
                        foreach(curItem ; all.trackName)
                        {
                           if( all !is null)
                           {
                              writeln(to!string(countItem)~" : "~curItem);
                              countItem++;
                           }
                        }
                        write("Numéro de la piste à modifier : ");
                        uint num = to!uint(std.string.removechars(readln(), "\n"));
                        if(num < countItem)
                        {
                           write("Nouveau nom de la piste : ");
                           string newTrack = std.string.removechars(readln(), "\n");
                           all.replaceTrackName(num, newTrack);
                           writeln("Nouveau nom pris en compte");
                        }
                        else
                        {
                           writeln("La piste "~to!string(num)~" n'existe pas");
                        }
                        break;

                     case "S":
                     case "s":
                        uint countItem = 0;
                        foreach(curItem ; all.trackName)
                        {
                           if( all !is null)
                           {
                              writeln(to!string(countItem)~" : "~curItem);
                              countItem++;
                           }
                        }
                        write("Numéro de la piste à supprimer : ");
                        uint num = to!uint(std.string.removechars(readln(), "\n"));
                        if(num < countItem)
                        {
                           all.removeTrackName(num);
                           writeln("Piste : "~to!string(num)~" Supprimée");
                        }
                        else
                        {
                           writeln("La piste "~to!string(num)~" n'existe pas");
                        }
                        break;
                     default:
                        writeln("Choix non valide !");
                  }
                  break;

               case "C":
               case "c":
                  write("Nouveau temps de l'album : ");
                  string newTime = std.string.removechars(readln(), "\n");
                  if(newTime.length > 1)
                  {
                     all.albumTime = to!uint(newTime);
                     writeln("Nouveau temps pris en compte");
                  }
                  else
                  {
                     writeln("Temps vide !");
                  }
                  break;
               default:
                  writeln("Choix non valide !");
            }
         }
         if(findAlbum == false)
         {
            writeln("Album "~item~" non trouvé");
         }
         else
         {
            write("Appuyez sur Entrée");
            readln();
            return;
         }
      }
   }
   else
   {
      write("Album vide\nAppuyez sur Entrée");
      readln();
   }
}