import std.stdio;
import std.file;
import std.conv;
import std.ascii;

import elements;
import gestionAlbums;
import xmlIO;

class Menu
{
   private:
      string[] _allItems;
      ElementCD[] _albums; /* Tous les albums */

   public:
      this()
      {
         _allItems ~= "+--------------------------------+";
         _allItems ~= "|           M.E.N.U              |";
         _allItems ~= "+--------------------------------+";
         _allItems ~= "| 1 - Charger.......un catalogue |";
         _allItems ~= "| 2 - Sauver........un catalogue |";
         _allItems ~= "| 3 - Supprimer.....un catalogue |";
         _allItems ~= "| 4 - Rennomer......un catalogue |";
         _allItems ~= "|--------------------------------|";
         _allItems ~= "| 5 - Ajouter ..........un album |";
         _allItems ~= "| 6 - Modifier..........un album |";
         _allItems ~= "| 7 - Supprimer.........un album |";
         _allItems ~= "| 8 - Lister.....tous les albums |";
         _allItems ~= "| 0 - Quitter                    |";
         _allItems ~= "+--------------------------------+";
      }

      bool afficheMenu()
      {
         foreach(item ; _allItems)
         {
            if( item is null)
            {
               write("Entrées vides\nAppuyez sur Entrée");
               readln();
               return false;
            }
            writeln(item);

         }
         write("\nVotre choix : ");

         string chx = std.string.removechars(choix(), "\n");
         switch(chx)
         {
            /* Quitter */
            case "0":
               return true;
            /* Charger catalogue */
            case "1":
               write("Nom du fichier à charger : ");
               string fileName = std.string.removechars(readln(), "\n");
               if(fileName.length > 1)
               {
                  _albums = xmlRead(fileName);
               }
               else
               {
                  writeln("Nom de fichier vide\nPressez Entrée pour retourner au menu.");
                  readln();
               }
               break;
            /* Sauver catalogue */
            case "2":
               write("Nom du fichier à sauver : ");
               string fileName = std.string.removechars(readln(), "\n");
               if(fileName.length > 1)
               {
                  xmlWrite(fileName, _albums);
               }
               else
               {
                  writeln("Nom de fichier vide\nPressez Entrée pour retourner au menu.");
                  readln();
               }
               break;
            /* Supprimer catalogue */
            case "3":
               write("Nom du fichier à supprimer : ");
               string fileName = std.string.removechars(readln(), "\n");
               if(fileName.length > 1)
               {
                  try
                  {
                     std.file.remove(fileName);
                  }
                  catch(FileException ex)
                  {
                     writeln(ex.msg);
                     writeln("Pressez Entrée pour retourner au menu.");
                     readln();
                     break;
                  }
                  writeln(fileName~" Supprimé\nPressez Entrée pour retourner au menu.");
                  readln();
               }
               else
               {
                  writeln("Nom de fichier vide\nPressez Entrée pour retourner au menu.");
                  readln();
               }
               break;
            /* Rennomer catalogue */
            case "4":
               write("Nom du fichier à rennomer : ");
               string fileNameS = std.string.removechars(readln(), "\n");
               write("Nouveau nom du fichier : ");
               string fileNameD = std.string.removechars(readln(), "\n");
               if(fileNameS.length > 1 && fileNameD.length >1)
               {
                  try
                  {
                     std.file.rename(fileNameS, fileNameD);
                  }
                  catch(FileException ex)
                  {
                     writeln(ex.msg);
                     writeln("Pressez Entrée pour retourner au menu.");
                     readln();
                     break;
                  }
                  writeln("Fichier "~fileNameS~" rennomé en "~fileNameD);
                  writeln("Pressez Entrée pour retourner au menu.");
                  readln();
               }
               else
               {
                  writeln("Nom de fichier vide\nPressez Entrée pour retourner au menu.");
                  readln();
               }
               break;
            /* Ajouter album */
            case "5":
               _albums ~= ajoutAlbum();
               break;
            /* Modifier album */
            case "6":
               write("Nom de l'album à modifier : ");
               string itemName = std.string.removechars(readln(), "\n");
               modifierAlbum(_albums, itemName);
               break;
            /* Supprimer album */
            case "7":
               write("Nom de l'album à supprimer : ");
               string itemName = std.string.removechars(readln(), "\n");
               supprimerAlbum(_albums, itemName);
               break;
            /* Lister albums */
            case "8":
               listAlbums(_albums);
               break;
            /* Entrée non disponible */
            default:
               write("Choix non disponible !\nAppuyez sur Entrée");
               readln();
               break;
         }
         return false;
      }

      string choix()
      {
         return readln();
      }
}
